//******************************************************************************
// Read Windows Wav file from Java
//******************************************************************************
import java.applet.*;
import java.awt.*;
import java.net.*;
import java.util.*;
import java.io.*;
import java.net.URL;
//----------Main Class-------------------------------------------
public class readwav extends Applet
{TextField tex0; 
 Button but1,but2,but3;
 WavFile  hl=new WavFile(); 
 UdpData udphl=new UdpData();
 
 int    ch=0,len=0,fre=0,bit=0;
 double t=0,a1=0,a2=0;
 short  x1[]=new short[16385];
 short  x2[]=new short[16385];
 byte   buffer[]=new byte[64540];
 int    par[]=new int[5];
  
 public readwav()
  { } 
 
 public String getAppletInfo()
  {return "Name:Java --> C \r\n"+"Author: He Lingsong\r\n";}	 		
 
 public void init()
 {Font NewFnt=new Font("Roman",Font.PLAIN,12);
  this.setFont(NewFnt);
  resize(540,300); setLayout(null);
  udphl=new UdpData(); 
  tex0=new TextField("");
  add(tex0);
  tex0.reshape(28,10,500,20);
  but1=new Button("Ding");
  add(but1);
  but1.reshape(130,260,60,20); 
  but2=new Button("Chord");
  add(but2);
  but2.reshape(230,260,60,20); 
  but3=new Button("UDP");
  add(but3);
  but3.reshape(330,260,60,20);  
  data("ding.wav");  
}
 
public boolean action(Event evt, Object o)
{if (evt.target==but1) data("ding.wav");
 if (evt.target==but2) data("chord.wav");
 if (evt.target==but3) data1();
 repaint();
 return true;
}

public void data(String name) // Read data file
{URL url1;
 try 
  {url1=new URL(getDocumentBase(),name);} 
 catch(Exception e) 
  {url1=getDocumentBase();}
 hl.read(url1,buffer,x1,x2,16384,par); 
 ch=par[0];
 fre=par[1];
 len=par[2];
 bit=par[3];   
}

public void data1() // get data from UDP Server
{String host;
 host="127.0.0.1";
 udphl.read(host,buffer,x1); 
 ch=1;
 fre=11025;
 len=1024;
 bit=16;   
}

public void paint(Graphics g)
{drawwave(g);
 tex0.setText("CH="+ch+",Fs="+fre+",Len="+len+",Bit="+bit+",A1="+a1+",A2="+a2+",T="+t);	
}

public void drawwave(Graphics g)
{int i,xx1,xx2,yy1,yy2; 
 double ff=1,sa,la,k,mm;
 g.setColor(Color.lightGray);
 g.fillRect(0,0,600,400); 
 g.setColor(Color.black);
 g.drawRect(28,40,500,200);
 g.drawString("A",14,50);  
 g.drawString("-A",8,240);
 g.drawString("0",14,145);
 g.drawString("0",30,255);
 g.drawString("T",525,255);
 t=500.0/fre;
 if (ch==0) return;  // Draw waveform of Channel1
 sa=la=x1[1];
 for (i=1;i<500;i++)  
  {if (sa>x1[i]) sa=x1[i];
   if (la<x1[i]) la=x1[i];
  }
 a1=Math.max(Math.abs(sa),Math.abs(la));
 k=1.2*a1; 
 ff=100.0/k; 
 g.setColor(Color.red); 
 for (i=1;i<500;i++)
  {xx1=28+i; 
   yy1=(int)(140-x1[i]*ff); 
   xx2=29+i; 
   yy2=(int)(140-x1[i+1]*ff);
   g.drawLine(xx1,yy1,xx2,yy2);
  }
 
 if (ch==1) return;  // Draw waveform of Channel2
 sa=la=x2[1];
 for (i=1;i<500;i++)  
 {if (sa>x2[i]) sa=x2[i];
  if (la<x2[i]) la=x2[i];
 }
 a2=Math.max(Math.abs(sa),Math.abs(la));
 k=1.2*a2; 
 ff=100.0/k; 
 g.setColor(Color.blue); 
 for (i=1;i<500;i++)
  {xx1=28+i; 
   yy1=(int)(140-x2[i]*ff); 
   xx2=29+i; 
   yy2=(int)(140-x2[i+1]*ff);
   g.drawLine(xx1,yy1,xx2,yy2);
  }
}
}


//==Class of get data froma UDP rort===========================
class UdpData 
{public UdpData()
 {}
 public void read(String host,byte[] buffer,short[] ch1) 
 {int i,len=0;
  InputStream in;
  OutputStream out;
  Socket server;
  try 
    {server=new Socket(host,8888,false);
     in=server.getInputStream();
     out=server.getOutputStream();     
     out.write(buffer,0,4);
	 out.flush();          
     len=in.read(buffer); 
     server.close();
    }
  catch(Exception exception) {len=0;}
  try
  {WindowsStream input=new WindowsStream(new ByteArrayInputStream(buffer));
   for (i=0;i<1024;i++) ch1[i]=input.readShort();
   }
   catch(Exception e) {;}   
  } 
 } 

//==Class of Read Windows Wav File===========================
class WavFile 
{public WavFile()
 {} 
 
 public void read(URL location,byte[] buffer,short[] ch1,short[] ch2,int max,int[] par) 
 {try
  {URLConnection con=location.openConnection();
   DataInputStream in= new DataInputStream(con.getInputStream());
   in.read(buffer);	 
   in.close(); 	   
  } 
  catch(Exception e) {;}      
  
  int i,m,bit=0,ch=0,fre=0,len=0;
  try
  {WindowsStream input=new WindowsStream(new ByteArrayInputStream(buffer));
   // Windows WAV File header
   input.readLong();             //8Byte 
   input.readLong();             //8Byte 
   input.readInt();              //4Byte
   input.readShort();            //2Byte
   ch=input.readShort();         //ch, 2Byte
   fre=input.readInt();          //fre,4Byte
   input.readInt();              //4Byte
   input.readShort();            //2Byte
   bit=input.readShort();        //2Byte
   input.readInt();              //4Byte
   len=input.readInt()*8/ch/bit; //Len,4Byte
   if (len>max) len=max;
   if (bit==16)
    for (i=0;i<len;i++)
     {ch1[i]=input.readShort();
	  if (ch==2) ch2[i]=input.readShort();
	 }
   if (bit==8)
    for (i=0;i<len;i++)
     {ch1[i]=(short)(input.readByte()-128);
	  if (ch==2) ch2[i]=(short)(input.readByte()-128);
	 }
 }
 catch(Exception e) {;}	 	
 par[0]=ch;
 par[1]=fre;
 par[2]=len;
 par[3]=bit;
}  

}

//=====Class of trans Windows I/O Stream to Java I/O Stream=======
class WindowsStream extends  FilterInputStream 
{
 public WindowsStream(InputStream in)
 {super(in);}
 
 public final int readInt() throws IOException      //Read int (4 byte)
 {InputStream in=this.in;
  int a1=in.read(); 
  int a2=in.read();
  int a3=in.read();	
  int a4=in.read();
  return ((a4<<24)+(a3<<16)+(a2<<8)+a1);
 } 
 
 public final long readLong() throws IOException     //Read long (8 byte)
 {InputStream in=this.in;
  return (readInt()<<32L)+(readInt()&0xFFFFFFFFL);
 }
 
 public final float readFloat() throws IOException   //Read float (4 byte)
 {return Float.intBitsToFloat(readInt());}
 
 public final double readDouble() throws IOException  //Read double(8 byte)
 {return Double.longBitsToDouble(readLong());} 
 
 public final byte readByte() throws IOException      //Read byte (1 byte)
 {int a=in.read();
  return (byte)(a); 
 }
 
 public final short readShort() throws IOException    //Read short(2 byte)
 {InputStream in = this.in;
  int a1 = in.read(); int a2 = in.read();
  return (short)((a2 << 8)+a1);
 }
}

